dhtmlxScheduler 与 Vue.js 集成指南

本指南假设您已经具备 Vue 的基本概念和使用模式。如果需要复习,可以参考 Vue 3 官方文档 中的快速入门教程。

DHTMLX Scheduler 能够与 Vue 平滑集成。您可以在 GitHub 上查看相关示例:DHTMLX Scheduler with Vue Demo

创建项目

在开始新项目之前,请确保已安装 Node.js

要创建 Vue 项目,请运行以下命令:

npm create vue@latest

此命令将安装并运行官方的 Vue 项目脚手架工具 create-vue。更多细节请参考 Vue.js 快速开始

安装依赖

接下来,进入应用目录。本指南项目名称为 scheduler-vue,运行:

cd scheduler-vue

然后使用包管理器安装依赖并启动开发服务器:

  • 如果使用 yarn,运行:
yarn install
yarn dev
  • 如果使用 npm,运行:
npm install
npm run dev

现在,您的 Vue 项目应该可以通过 http://localhost:5173 访问。

Scheduler Vue.js app running

创建 Scheduler

在添加 Scheduler 之前,请通过在终端按下 Ctrl+C 停止正在运行的应用。之后,继续安装 Scheduler 包。

第一步:安装包

该库的 PRO 版本可通过 npm/yarn 从我们的私有仓库获取。请按照 此说明 获取访问权限。

获得 Scheduler 的 Evaluation 版本后,使用以下命令安装:

  • npm:
npm install @dhx/trial-scheduler
  • yarn:
yarn add @dhx/trial-scheduler

另外,由于库的 zip 包结构为 npm 模块,您也可以 从本地文件夹安装

第二步:创建组件

创建一个 Vue 组件,将 Scheduler 集成进您的应用。在 src/components/ 目录下添加新文件 Scheduler.vue

导入源文件

打开 Scheduler.vue 并导入 Scheduler 源文件。根据您的安装方式:

  • 如果是本地文件夹安装,导入如下:

Scheduler.vue

import { Scheduler } from "dhtmlx-scheduler";<style>
  @import "@dhtmlx-scheduler/codebase/dhtmlxscheduler.css";
</style>
  • 如果是 trial 版本,导入如下:

Scheduler.vue

import { Scheduler } from "@dhx/trial-scheduler";<style>
  @import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
</style>

本教程采用 trial 版本的 Scheduler。

设置容器并添加 Scheduler

要在页面上渲染 Scheduler,需要设置容器元素。相关代码如下:

Scheduler.vue

<script>
import { Scheduler } from "@dhx/trial-scheduler";
import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
 
export default {
  mounted() {
    let scheduler = Scheduler.getSchedulerInstance();
    let date = scheduler.init(this.$refs.cont, new Date(2023, 9, 6), "week");
    this.scheduler = scheduler;
  },
  unmounted() {
    this.scheduler.destructor();
    this.$refs.cont.innerHTML = "";
  },
};
</script>   <template> <div ref="cont" style="width: 100%; height: 100vh"></div> </template>

如果希望 Scheduler 容器填满整个 body,请移除 src/assets 文件夹下 main.css 的默认样式,并替换为:

src/assets/main.css

#app {
  margin: 0;
  padding: 0;
  height: 100%;
  width: 100%;
}

第三步:将 Scheduler 添加到应用

接下来,将 Scheduler 组件添加到应用中。打开 src/App.vue,将默认内容替换为:

src/App.vue

<script>
import Scheduler from "./components/Scheduler.vue";
 
export default {
  components: { Scheduler },
};
</script>   <template> <Scheduler/> </template>

运行应用后,页面上将显示一个空的 Scheduler:

Scheduler Vue init

第四步:提供数据

要在 Scheduler 中显示事件,需要提供数据。在 src/ 目录下创建名为 data.js 的文件,并添加一些示例事件:

src/data.js

export function getData() {
    const data = [
        {
            start_date: "2024-06-10 6:00",
            end_date: "2024-06-10 8:00",
            text: "Event 1",
            id: 1,
        },
        {
            start_date: "2024-06-13 10:00",
            end_date: "2024-06-13 18:00",
            text: "Event 2",
            id: 2,
        },
    ];
    return data;
}

App.vue 中将此数据作为 props 传递给 Scheduler 组件:

App.vue

<script>
import Scheduler from "./components/Scheduler.vue";
import { getData } from "./data";
 
export default {
  components: { Scheduler },
  data() {
    return {
      events: getData(),
    };
  },
};
</script>   <template> <Scheduler :events="events" /> </template>

然后,在 Scheduler 组件内部通过 scheduler.parse() 方法使用该 props:

Scheduler.vue

<script>
import { Scheduler } from "@dhx/trial-scheduler";
import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
 
export default {
  props: ["events"],
  mounted() {
    let scheduler = Scheduler.getSchedulerInstance();
    let date = scheduler.init(this.$refs.cont, new Date(2023, 5, 10), "week");
    scheduler.parse(this.events);
 
    this.scheduler = scheduler;
  },
  unmounted() {
    this.scheduler.destructor();
    this.$refs.cont.innerHTML = "";
  },
};
</script>   <template> <div ref="cont" style="width: 100%; height: 100vh"></div> </template>

重新加载页面后,Scheduler 将显示已填充的事件:

Scheduler Vue events

第五步:保存数据

要跟踪 Scheduler 内的更改,可以使用 dataProcessor 处理器,它用于与服务器后端通信。该处理器可定义为函数或路由对象。dhtmlxScheduler 支持处理器返回 Promise,以确保正确处理操作完成。

通过 createDataProcessor() API 方法创建 DataProcessor,并像这样捕获更改:

scheduler.createDataProcessor(function(entity, action, data, id) {​
    scheduler.message(`${​entity} ${​action}`);
});

如果后端在新建记录后会更改事件 ID(常见场景),请确保 Promise 返回包含 {id: databaseId}{tid: databaseId} 的对象。这样 Scheduler 可以用新的数据库 ID 更新记录。详细信息参见 server side integration

至此,您的 Vue Scheduler 集成已完成。欢迎在 GitHub 上查看完整演示:https://github.com/DHTMLX/vue-scheduler-demo

XSS、CSRF 及 SQL 注入攻击

请注意,Scheduler 本身不提供对 SQL 注入、XSS 或 CSRF 攻击的防护。确保应用安全是开发者的责任,尤其是后端实现时。

请参考 Application Security 文章,了解组件的潜在风险点及提升应用安全性的措施。

返回顶部

dhtmlxScheduler 与 React 集成指南

本指南假定您已基本了解 React 的相关概念和模式。如果您是 React 新手,建议先阅读 React 官方文档 入门教程。

DHTMLX Scheduler 可以很好地与 React 集成。您可以在 GitHub 上找到相关示例:DHTMLX Scheduler with React Demo

创建项目

在创建项目之前,请确保已安装 Node.js

要搭建一个简单的 React 项目,请运行以下命令:

npx create-vite my-react-scheduler-app --template react

安装依赖

接下来,进入您的应用目录。本例中使用 my-react-scheduler-app

cd my-react-scheduler-app

然后使用您喜欢的包管理器安装依赖并启动开发服务器:

  • 如果使用 yarn,运行:
yarn install
yarn dev
  • 如果使用 npm,运行:
npm install
npm run dev

您的 React 项目现在应该可以通过 http://localhost:5173 访问。

Scheduler React app running

创建 Scheduler

要添加 DHTMLX Scheduler,首先通过命令行按 Ctrl+C 停止应用。然后继续安装 Scheduler 包。

步骤 1. 安装包

库的 PRO 版本可通过我们的私有仓库使用 npm/yarn 获取。请参考 此说明 获取访问权限。

获得 Scheduler 的 Evaluation 版本后,使用以下命令之一安装:

  • 使用 npm:
npm install @dhx/trial-scheduler
  • 使用 yarn:
yarn add @dhx/trial-scheduler

另外,由于库的 zip 包结构与 npm 模块兼容,您也可以 从本地文件夹安装

步骤 2. 创建组件

接下来,创建一个 React 组件用于在应用中集成 Scheduler。新建文件夹 src/components/Scheduler,并在其中创建以下文件:Scheduler.jsxScheduler.cssindex.js

首先创建 Scheduler.css,为 scheduler-container 添加样式:

src/components/Scheduler/Scheduler.css

.scheduler-container {
    height: 100vh;
    width: 100vw;
}

为确保 Scheduler 容器填满整个页面,请删除 src 文件夹下 App.css 的默认样式,并添加如下内容:

#root {
  margin: 0;
  padding: 0;
  height: 100%;
  width: 100%;
}

然后添加 index.js 文件,内容如下:

src/components/Scheduler/index.js

import Scheduler from './Scheduler';
import './Scheduler.css';
export default Scheduler;

导入源文件

打开 Scheduler.jsx 并导入 Scheduler 源文件。根据您安装包的方式,导入代码如下:

  • 如果从本地文件夹安装:

Scheduler.jsx

import { Scheduler } from 'dhtmlx-scheduler';
import 'dhtmlx-scheduler/codebase/dhtmlxscheduler.css';
  • 如果使用 trial 版本:

Scheduler.jsx

import { Scheduler } from '@dhx/trial-scheduler';
import '@dhx/trial-scheduler/codebase/dhtmlxscheduler.css';

本教程使用 trial 版本。

设置容器并添加 Scheduler

要在页面上渲染 Scheduler,需要设置一个容器。创建 Scheduler.jsx,内容如下:

src/components/Scheduler/Scheduler.jsx

import { useEffect, useRef } from "react";
import { Scheduler } from "@dhx/trial-scheduler";
import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
 
export default function SchedulerView( ) {
    let container = useRef();
    useEffect(() => {
        let scheduler = Scheduler.getSchedulerInstance();
        scheduler.skin = "terrace";
        scheduler.config.header = [
            "day",
            "week",
            "month",
            "date",
            "prev",
            "today",
            "next",
        ];
 
        scheduler.init(container.current, new Date(2024, 5, 10));
        return () => {
            scheduler.destructor();
            container.current.innerHTML = "";
        };
    }, []);
 
    return (
        <div ref={container} style=width: "100%", height: "100%"></div>
    );
}

步骤 3. 将 Scheduler 添加到应用中

现在将 Scheduler 组件添加到您的应用中。打开 src/App.jsx,将默认内容替换为:

src/App.jsx

import Scheduler from "./components/Scheduler";
import "./App.css";
 
function App() {
    return (
        <div className="scheduler-container">
            <Scheduler/>
        </div>
    );
}
export default App;

重新启动应用后,页面上会出现一个空白的 Scheduler:

Scheduler React init

步骤 4. 提供数据

要在 Scheduler 中显示事件,需要提供一组数据。在 src/ 目录下创建 data.js 并添加一些事件:

src/data.js

export function getData() {
    const data = [
        {
            start_date: "2024-06-10 6:00",
            end_date: "2024-06-10 8:00",
            text: "Event 1",
            id: 1,
        },
        {
            start_date: "2024-06-13 10:00",
            end_date: "2024-06-13 18:00",
            text: "Event 2",
            id: 2,
        },
    ];
    return data;
}

然后,在 App.jsx 中将此数据作为 props 传递给 Scheduler 组件:

App.jsx

import { getData } from "./data.js";
import Scheduler from "./components/Scheduler";
import "./App.css";
 
function App() {
    return (
        <div className="scheduler-container">
            <Scheduler events={getData()}/>
        </div>
    );
}
export default App;

在 Scheduler 组件中,通过 scheduler.parse() 方法使用该 props:

Scheduler.jsx

import { useEffect, useRef } from "react";
import { Scheduler } from "@dhx/trial-scheduler";
import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
 
export default function SchedulerView({events}) {
    let container = useRef();
    useEffect(() => {
        let scheduler = Scheduler.getSchedulerInstance();
        scheduler.skin = "terrace";
        scheduler.config.header = [
            "day",
            "week",
            "month",
            "date",
            "prev",
            "today",
            "next",
        ];
 
        scheduler.init(container.current, new Date(2024, 5, 10));
        scheduler.parse(events);
        return () => {
            scheduler.destructor();
            container.current.innerHTML = "";
        };
    }, []);
 
    return (
        <div ref={container} style=width: "100%", height: "100%"></div>
    );
}

现在刷新页面,Scheduler 会加载显示事件:

Scheduler React events

步骤 5. 保存数据

要处理 Scheduler 中的变更,可以使用 dataProcessor 处理器。这样可以与您的后端服务器通信。该处理器可以是函数或路由对象。dhtmlxScheduler 支持 handler 返回 Promise,因此可以正确处理操作完成。

通过 createDataProcessor() 创建 DataProcessor 并捕获变更,如下:

scheduler.createDataProcessor(function(entity, action, data, id) {​
    scheduler.message(`${​entity} ${​action}`);
});

如果您的后端在创建新事件后会更改事件 id(常见情况),请确保 Promise 返回一个包含 {id: databaseId}{tid: databaseId} 的对象。这样 Scheduler 会将记录更新为新的数据库 id。更多细节请参见 server side integration

至此,React Scheduler 的基本集成已完成。您可以在 GitHub 上查看完整演示:DHTMLX react-scheduler-demo

XSS、CSRF 和 SQL 注入攻击

请注意,Scheduler 本身不提供针对 SQL 注入、XSS 或 CSRF 等安全威胁的防护。保护您的应用免受这些风险是后端开发者的责任。

请参考 应用安全 文章,了解常见漏洞及如何提升应用安全性。

返回顶部

dhtmlxScheduler 与 Angular 集成指南

本指南假设你已经具备 Angular 的基础知识和开发模式。如果你是初学者,建议先阅读 Angular 文档 以获取入门教程。

DHTMLX Scheduler 能够顺利地与 Angular 集成。你可以在 GitHub 上找到一个实际示例:DHTMLX Scheduler with Angular Demo

创建项目

在开始新项目之前,请确保你已经安装了 Angular CLINode.js。然后运行以下命令:

ng new my-angular-scheduler-app

该命令会为你配置好所需的工具和依赖,无需额外步骤。

安装依赖

接下来,进入应用目录:

cd my-angular-scheduler-app

使用以下任一命令启动应用:

yarn start

npm start

现在你可以通过 http://localhost:4200 访问应用。

Scheduler with Angular

创建 Scheduler

要添加 DHTMLX Scheduler,首先请在终端使用 Ctrl+C 停止正在运行的应用。然后继续安装 Scheduler 包。

步骤 1. 安装包

库的 PRO 版本可通过 npm/yarn 从我们的私有仓库获取。请参阅 此说明 以获取访问权限。

获得 Evaluation 版本后,使用以下命令安装:

  • npm:
npm install @dhx/trial-scheduler
  • yarn:
yarn add @dhx/trial-scheduler

另外,由于库的 zip 包结构为 npm 模块,你也可以 从本地文件夹安装

步骤 2. 创建组件

创建一个新组件以集成 Scheduler。在 src/app/ 目录下,新建 scheduler 文件夹并添加以下文件:scheduler.component.tsscheduler.component.cssscheduler.component.html

scheduler.component.html 中,为 scheduler 添加如下模板:

scheduler/scheduler.component.html

<div #scheduler_here class="dhx_cal_container" style="width: 100%; height:100vh">
   <div class="dhx_cal_navline">
       <div class="dhx_cal_prev_button"></div>
       <div class="dhx_cal_next_button"></div>
       <div class="dhx_cal_today_button"></div>
       <div class="dhx_cal_date"></div>
       <div class="dhx_cal_tab" data-tab="day"></div>
       <div class="dhx_cal_tab" data-tab="week"></div>
       <div class="dhx_cal_tab" data-tab="month"></div>
   </div>
   <div class="dhx_cal_header"></div>
   <div class="dhx_cal_data"></div>
</div>

将 scheduler 的样式单独声明在 scheduler.component.css。以下是一个基础示例:

scheduler/scheduler.component.css

@import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
:host {
   display: block;
   position: relative;
   height: 100%;
   width: 100%;
}

为了确保 Scheduler 容器填满整个页面,在 src 文件夹下的 styles.css 中添加如下样式:

src/styles.css

html,
body {
  margin: 0;
  padding: 0;
  height: 100%;
  width: 100%;
}

导入源文件

打开 scheduler.component.tsscheduler.component.css,导入 Scheduler 源文件。根据你的安装方式:

  • 如果从本地文件夹安装,导入方式如下:

scheduler.component.ts

import { Scheduler, SchedulerStatic } from 'dhtmlx-scheduler';

scheduler.component.css

@import "@dhtmlx-scheduler/codebase/dhtmlxscheduler.css";
  • 如果使用 trial 版本,导入方式如下:

scheduler.component.ts

import { Scheduler, SchedulerStatic } from '@dhx/trial-scheduler';

scheduler.component.css

@import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";

本教程采用 trial 版本。

设置容器并添加 Scheduler

为了在页面上显示 Scheduler,需要设置其渲染的容器。代码如下:

scheduler.component.ts

import { Scheduler, SchedulerStatic } from "@dhx/trial-scheduler";
import { Component, ElementRef, OnInit, OnDestroy, 
    ViewChild, ViewEncapsulation } from "@angular/core";
 
@Component({
  encapsulation: ViewEncapsulation.None,
  selector: "scheduler",
  styleUrls: ["./scheduler.component.css"],
  templateUrl: 'scheduler.component.html'
})
 
export class SchedulerComponent implements OnInit, OnDestroy {
  @ViewChild("scheduler_here", { static: true }) schedulerContainer!: ElementRef;
  private _scheduler?: SchedulerStatic;
 
  ngOnInit() {
    let scheduler = Scheduler.getSchedulerInstance();
    scheduler.init(
      this.schedulerContainer.nativeElement,
      new Date(2024, 9, 7),
      "week", 
    );
    this._scheduler = scheduler;
  }
 
  ngOnDestroy() {
    if (this._scheduler) this._scheduler.destructor();
  }
}

这里,ngOnInit() 生命周期钩子用于初始化 Scheduler,ngOnDestroy() 在组件销毁时调用 scheduler.destructor() 进行清理。

步骤 3. 将 Scheduler 添加到应用中

接下来,用 Scheduler 组件替换默认内容。打开 src/app/app.component.ts,并更新如下:

src/app/app.component.ts

import { Component } from '@angular/core';
 
@Component({
  selector: 'app-root',
  template: `<scheduler></scheduler>`,
})
export class AppComponent {
  name = '';
}

src/app/ 下创建 app.module.ts,并按如下方式引入 SchedulerComponent

src/app/app.module.ts

import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";
 
import { AppComponent } from "./app.component";
import { SchedulerComponent } from "./scheduler/scheduler.component";
 
@NgModule({
  declarations: [AppComponent, SchedulerComponent],
  imports: [BrowserModule],
  providers: [],
  bootstrap: [AppComponent],
})
export class AppModule {}

最后,更新 src/main.ts,替换其内容为:

src/main.ts

import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { AppModule } from "./app/app.module";
 
platformBrowserDynamic()
  .bootstrapModule(AppModule)
  .catch((err) => console.error(err));

再次启动应用后,页面上会显示一个空的 Scheduler。

Adding Scheduler into an app

步骤 4. 提供数据

要在 Angular Scheduler 中加载数据,需要添加事件服务。在此之前,需定义事件模型。

使用以下命令创建事件模型:

ng generate class models/event --skip-tests

models 文件夹中新建的 event.ts 文件中,添加如下代码:

models/event.ts

export class Event {
    id!:  number;
    start_date!: string;
    end_date!: string;
    text!: string;
}

接下来,创建事件服务。该服务类负责管理特定事件。在 Angular 中,服务可以通过依赖注入进行注入。服务可包含应用所需的数据、函数或特性。这里我们创建一个数据服务,为 scheduler 提供事件。

生成事件服务的命令如下:

ng generate service services/event --flat --skip-tests

services 文件夹中新建的 event.service.ts 文件中,加入如下代码:

services/event.service.ts

import { Injectable } from '@angular/core';
import { Event } from "../models/event";
 
@Injectable()
export class EventService {
    get(): Promise<Event[]>{
        return Promise.resolve([
            { id: 1, start_date: "2023-05-16 09:00", end_date: "2023-05-16 13:00", 
                text: "Event 1" },
            { id: 2, start_date: "2023-05-18 10:00", end_date: "2023-05-18 14:00", 
                text: "Event 2" },
        ]);
    }
}

@Injectable() 装饰器标记该服务可用于注入。稍后会将此服务注入到组件中。

目前,get() 方法返回一个包含硬编码事件的已解析 Promise。当然也可以从服务器加载数据并返回 Promise。scheduler 组件将使用 EventService 获取事件。为此,首先在 scheduler.component.ts 中引入 EventService

scheduler.component.ts

import {EventService} from "../services/event.service";

然后,在 @Component 装饰器中将 EventService 指定为 provider:

scheduler.component.ts

@Component({
  encapsulation: ViewEncapsulation.None,
  selector: "scheduler",
  providers: [EventService],
  styleUrls: ["./scheduler.component.css"],
  templateUrl: 'scheduler.component.html'
})

这样,每次创建 SchedulerComponent 时都会提供一个新的服务实例。要将服务注入到组件中,在 SchedulerComponent 类中添加如下构造函数:

scheduler.component.ts

constructor(private eventService: EventService){}

ngOnInit() 方法更新为:

  • 设置事件加载的数据格式(此处采用 XML 格式)
  • 调用服务获取事件,并在获取数据后传递给 scheduler

scheduler.component.ts

scheduler.config.date_format = "%Y-%m-%d %H:%i";
scheduler.init(this.schedulerContainer.nativeElement, new Date(2024, 9, 7));
this.eventService.get()
    .then((data) => {
         scheduler.parse(data);
    });

完整的 scheduler.component.ts 文件如下:

scheduler.component.ts

import { Scheduler, SchedulerStatic } from "@dhx/trial-scheduler";
import { Component, ElementRef, OnInit, OnDestroy, 
    ViewChild, ViewEncapsulation } from "@angular/core";
import {EventService} from "../services/event.service";
 
@Component({
  encapsulation: ViewEncapsulation.None,
  selector: "scheduler",
  providers: [EventService],
  styleUrls: ['scheduler.component.css'],
  templateUrl: 'scheduler.component.html'
})
 
export class SchedulerComponent implements OnInit, OnDestroy {
  @ViewChild("scheduler_here", { static: true }) schedulerContainer!: ElementRef;
  private _scheduler?: SchedulerStatic;
  constructor(private eventService: EventService) { }
 
  ngOnInit() {
    let scheduler = Scheduler.getSchedulerInstance();
    scheduler.config.date_format = "%Y-%m-%d %H:%i";
    scheduler.init(
      this.schedulerContainer.nativeElement,
      new Date(2024, 9, 7),
      "week", 
    );
    this.eventService.get().then((data) => {scheduler.parse(data);});
    this._scheduler = scheduler;
  }
 
  ngOnDestroy() {
    if (this._scheduler) this._scheduler.destructor();
  }
}

重新打开应用页面后,Scheduler 应会显示事件数据。

Scheduler with Angular events

第5步:保存数据

为了跟踪在 Scheduler 中所做的更改,可以使用 dataProcessor 处理器与后端进行通信。该处理器可以定义为一个函数或路由对象。dhtmlxScheduler 支持处理器返回 Promise,从而确保对操作的正确处理。

可以使用 createDataProcessor() API 方法创建 DataProcessor,以捕获更改,如下所示:

scheduler.createDataProcessor(function(entity, action, data, id) {​
    scheduler.message(`${​entity} ${​action}`);
});

如果服务在创建新记录后修改了事件 ID(这很常见),Promise 应返回包含 {id: databaseId}{tid: databaseId} 的对象。这样 Scheduler 就能用新的数据库 ID 更新记录。

关于服务端集成的更多细节,请参阅这里

现在 Angular Scheduler 已经配置完成。欢迎在 GitHub 上查看完整演示

XSS、CSRF 和 SQL 注入攻击

请注意,Scheduler 本身并不提供对 SQL 注入、XSS 或 CSRF 等威胁的防护。确保应用安全是后端开发人员的责任。

有关潜在安全漏洞和推荐的安全做法的更多信息,请参见 Application Security 文章。

返回顶部

dhtmlxScheduler 与 Svelte 集成指南

本指南假设您已具备 Svelte 的基本概念和使用模式。如需入门,请参考 Svelte 官方文档 提供的教程。

DHTMLX Scheduler 可与 Svelte 很好地配合使用。您可以在 GitHub 上查看实际示例:DHTMLX Scheduler with Svelte Demo

创建项目

在创建新项目之前,请确保已安装 Vite(可选)和 Node.js

使用 Vite 创建 Svelte 项目,请运行以下命令:

npm create vite@latest

更多细节可参考 相关文档

安装依赖

接下来,进入您的应用目录。假设项目名称为 scheduler-svelte 并选择 svelte 选项。然后执行:

cd scheduler-svelte

之后,使用您喜欢的包管理器安装依赖并启动应用:

  • 使用 yarn
yarn install
yarn dev
  • 使用 npm
npm install
npm run dev

您的 Svelte 项目现在应该可以通过 http://localhost:5173 访问。

Scheduler Svelte app running

创建 Scheduler

要添加 DHTMLX Scheduler,首先在终端按 Ctrl+C 停止应用。然后安装 Scheduler 包。

步骤 1. 安装包

库的 PRO 版本可通过 npm/yarn 从我们的私有仓库获取。请按照 此说明 获取访问权限。

获得 Evaluation 版本后,使用以下命令安装:

  • npm:
npm install @dhx/trial-scheduler
  • yarn:
yarn add @dhx/trial-scheduler

另外,由于库的 zip 包结构为 npm 模块,您也可以 从本地文件夹安装

步骤 2. 创建组件

创建新的 Svelte 组件以在应用中添加 Scheduler。在 src/ 目录下新建文件 Scheduler.svelte

导入源文件

打开 Scheduler.svelte 并导入 Scheduler 文件。根据您的安装方式:

  • 如果从本地文件夹安装,导入如下:

Scheduler.svelte

import { Scheduler } from "dhtmlx-scheduler";
import "dhtmlx-scheduler/codebase/dhtmlxscheduler.css";
  • 如果使用 trial 版本,导入如下:

Scheduler.svelte

import { Scheduler } from "@dhx/trial-scheduler";
import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";

本指南采用 trial 版本。

设置容器并添加 Scheduler

为显示 Scheduler,需定义一个容器元素。如下代码所示:

Scheduler.svelte

<script>
    import { onMount } from "svelte";
    import { Scheduler } from "@dhx/trial-scheduler";
    import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
 
    let scheduler;
    let container;
    onMount(() => {
        scheduler = Scheduler.getSchedulerInstance();
        scheduler.skin = "terrace";
        scheduler.init(container, new Date(2023, 9, 6), "week");
 
        return () => scheduler.destructor();
    });
</script>   <div bind:this={container} style="width: 100%; height: 100vh;"></div>

如需让 Scheduler 容器填满整个页面,请移除 src/app.css 的默认样式,并添加:

src/app.css

body {
  margin: 0;
  padding: 0;
  height: 100%;
  width: 100%;
}

步骤 3. 在应用中添加 Scheduler

接下来,将 Scheduler 组件引入您的应用。在 src/App.svelte 中用以下内容替换默认内容:

App.svelte

<script>
  import Scheduler from "./Scheduler.svelte";
</script>   <Scheduler/>

启动应用后,页面上应会显示一个空的 Scheduler:

Scheduler Svelte init

步骤 4. 提供数据

要显示事件,需要为 Scheduler 提供数据。在 src/ 下新建 data.js 文件,并添加一些示例数据:

src/data.js

export function getData() {
    const data = [
        {
            start_date: "2024-06-10 6:00",
            end_date: "2024-06-10 8:00",
            text: "Event 1",
            id: 1,
        },
        {
            start_date: "2024-06-13 10:00",
            end_date: "2024-06-13 18:00",
            text: "Event 2",
            id: 2,
        },
    ];
    return data;
}

然后,将该数据作为 prop 传递给 Scheduler 组件,在 App.svelte 中:

App.svelte

<script>
  import Scheduler from "./Scheduler.svelte";
  import { getData } from "./data.js";
</script>   <Scheduler data={getData()} />

Scheduler.svelte 内,使用该 prop 并通过 scheduler.parse() 加载数据:

Scheduler.svelte

<script>
    import { onMount } from "svelte";
 
    import { Scheduler } from "@dhx/trial-scheduler";
    import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css"
    export let data;  
    let scheduler;
    let container;
    onMount(() => {
        scheduler = Scheduler.getSchedulerInstance();
        scheduler.skin = "terrace"
        scheduler.init(container, new Date(2024, 5, 10), "week");
 
        return () => scheduler.destructor();
    });
 
    $: scheduler?.parse(data);
</script>   <div bind:this={container} style="width: 100%; height: 100vh;"></div>

重新加载应用后,Scheduler 中将显示事件:

Scheduler Svelte events

步骤 5. 数据保存

要处理 Scheduler 中的更改,可使用 dataProcessor 处理器,实现与后端的通信。该处理器可以是函数或路由对象。dhtmlxScheduler 支持 Promise 响应,因此会等待操作完成。

使用 createDataProcessor() 创建 DataProcessor 并捕获更改:

scheduler.createDataProcessor(function(entity, action, data, id) {​
    scheduler.message(`${​entity} ${​action}`);
});

如果您的后端在创建新记录时会更改事件 ID(常见情况),请确保 Promise 返回的对象格式为 {id: databaseId}{tid: databaseId},以便 Scheduler 正确更新事件。更多信息请参考 server side integration

至此,您的 Svelte Scheduler 已准备就绪。欢迎在 GitHub 上查看完整示例:svelte-scheduler-demo

XSS、CSRF 及 SQL 注入攻击

请注意,Scheduler 本身不提供针对 SQL 注入、XSS 或 CSRF 等威胁的防护。应用安全需由后端开发者负责。

请参考 Application Security 文章,了解组件的潜在风险点及推荐安全措施。

返回顶部